<?php
class ControllerOctemplatesBlogSetting extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('octemplates/blog_setting');

		$this->load->model('setting/setting');
    $this->load->model('extension/extension');
    $this->load->model('user/user_group');
    $this->load->model('octemplates/blog_setting');

		if (!in_array('oct_blog_setting', $this->model_extension_extension->getInstalled('module'))) {
			
			$this->model_octemplates_blog_setting->installTables();

			$this->model_user_user_group->addPermission($this->user->getId(), 'access', 'octemplates/blog_setting');
	    $this->model_user_user_group->addPermission($this->user->getId(), 'modify', 'octemplates/blog_setting');
			$this->model_user_user_group->addPermission($this->user->getId(), 'access', 'octemplates/blog_category');
	    $this->model_user_user_group->addPermission($this->user->getId(), 'modify', 'octemplates/blog_category');
	    $this->model_user_user_group->addPermission($this->user->getId(), 'access', 'octemplates/blog_article');
	    $this->model_user_user_group->addPermission($this->user->getId(), 'modify', 'octemplates/blog_article');
	    $this->model_user_user_group->addPermission($this->user->getId(), 'access', 'octemplates/blog_comments');
	    $this->model_user_user_group->addPermission($this->user->getId(), 'modify', 'octemplates/blog_comments');

	    $this->model_setting_setting->editSetting('oct_blog_setting', array(
	        'oct_blog_setting_data' => array(
	          'status' => '1',
	          'comment_moderation' => '1',
	          'desc_limit' => '400',
	          'main_image_width' => '228',
	          'main_image_height' => '228',
	          'main_image_popup_width' => '500',
	          'main_image_popup_height' => '500',
	          'sub_image_width' => '228',
	          'sub_image_height' => '228',
	          'r_p_image_width' => '228',
	          'r_p_image_height' => '228',
	          'r_a_image_width' => '228',
	          'r_a_image_height' => '228',
	          'a_image_width_in_category' => '228',
	          'a_image_height_in_category' => '228',
	          'comment_write' => '1',
	          'comment_show' => '1',
	          'c_image_width' => '80',
						'c_image_height' => '80'
	        )
	      )
			);        

      $this->model_extension_extension->install('module', 'oct_blog_setting');
    }

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('oct_blog_setting', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('octemplates/blog_setting', 'token=' . $this->session->data['token'], 'SSL'));
		}

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');

		$data['tab_setting'] = $this->language->get('tab_setting');

		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_comment_moderation'] = $this->language->get('entry_comment_moderation');
		$data['entry_desc_limit'] = $this->language->get('entry_desc_limit');
		$data['entry_main_image_width'] = $this->language->get('entry_main_image_width');
		$data['entry_main_image_height'] = $this->language->get('entry_main_image_height');
		$data['entry_main_image_popup_width'] = $this->language->get('entry_main_image_popup_width');
		$data['entry_main_image_popup_height'] = $this->language->get('entry_main_image_popup_height');
		$data['entry_comment_show'] = $this->language->get('entry_comment_show');
		$data['entry_comment_write'] = $this->language->get('entry_comment_write');
		$data['entry_sub_image_width'] = $this->language->get('entry_sub_image_width');
		$data['entry_sub_image_height'] = $this->language->get('entry_sub_image_height');
		$data['entry_r_p_image_width'] = $this->language->get('entry_r_p_image_width');
		$data['entry_r_p_image_height'] = $this->language->get('entry_r_p_image_height');
		$data['entry_r_a_image_width'] = $this->language->get('entry_r_a_image_width');
		$data['entry_r_a_image_height'] = $this->language->get('entry_r_a_image_height');
		$data['entry_a_image_width_in_category'] = $this->language->get('entry_a_image_width_in_category');
		$data['entry_a_image_height_in_category'] = $this->language->get('entry_a_image_height_in_category');
		$data['entry_c_image_width'] = $this->language->get('entry_c_image_width');
		$data['entry_c_image_height'] = $this->language->get('entry_c_image_height');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');
		$data['button_uninstall'] = $this->language->get('button_uninstall');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];

			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('octemplates/blog_setting', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['action'] = $this->url->link('octemplates/blog_setting', 'token=' . $this->session->data['token'], 'SSL');
		$data['uninstall'] = $this->url->link('octemplates/blog_setting/uninstall', 'token=' . $this->session->data['token'], 'SSL');
		$data['cancel'] = $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL');

		if (isset($this->request->post['oct_blog_setting_data'])) {
			$data['oct_blog_setting_data'] = $this->request->post['oct_blog_setting_data'];
		} else {
			$data['oct_blog_setting_data'] = $this->config->get('oct_blog_setting_data');
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('octemplates/blog_setting.tpl', $data));
	}

  public function uninstall() {
  	$this->load->language('octemplates/blog_setting');

		$this->load->model('extension/extension');

		$this->model_extension_extension->uninstall('module', 'oct_blog_setting');

    $this->load->model('setting/setting');

    $this->model_setting_setting->deleteSetting('oct_blog_setting');

    $this->load->model('octemplates/blog_setting');

		$this->model_octemplates_blog_setting->deleteTables();

    $this->session->data['success'] = $this->language->get('text_success_uninstall');
     
    $this->response->redirect($this->url->link('extension/module', 'token='.$this->session->data['token'], 'SSL'));
  }

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'octemplates/blog_setting')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}
}