<?php
class ControllerModuleOctPopupAddToWishlist extends Controller {
	public function index() {
		$data = array();

		$this->load->model('catalog/product');
		$this->load->language('module/oct_popup_add_to_wishlist');

		if (isset($this->request->get['product_id'])) {
			$product_id = (int)$this->request->get['product_id'];
		} else {
			$product_id = 0;
		}

		$data['button_ok'] = $this->language->get('button_ok');

		$product_info = $this->model_catalog_product->getProduct($product_id);

		if ($product_info) {

			if (!$this->customer->isLogged()) {
				$data['heading_title'] = $this->language->get('heading_title_no');
				$data['success_add'] = false;
				$data['text_warning_add'] = sprintf($this->language->get('text_warning_add'), $this->url->link('account/login', '', 'SSL'), $this->url->link('account/register', '', 'SSL'), $this->url->link('product/product', 'product_id=' . (int)$product_id), $product_info['name'], $this->url->link('account/wishlist'));
			} else {
				$data['heading_title'] = $this->language->get('heading_title_ok');
				$data['success_add'] = true;
				$data['text_success_add'] = $this->language->get('text_success_add');
				$data['text_wishlist'] = $this->language->get('text_wishlist');

				$data['wishlist_url'] = $this->url->link('account/wishlist');
			}

		  $data['product_name'] = $product_info['name'];

			if(file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/module/oct_popup_add_to_wishlist.tpl')) {
				$view = $this->load->view($this->config->get('config_template') . '/template/module/oct_popup_add_to_wishlist.tpl', $data);
			} else {
				$view = $this->load->view('default/template/module/oct_popup_add_to_wishlist.tpl', $data);
			}

			$this->response->setOutput($view);
		}
	}
}