<?php
class ControllerModuleOctPopupView extends Controller {
  public function index() {
    
    $data = array();

    $this->load->model('catalog/product');
    $this->load->language('module/oct_popup_view');

    $oct_popup_view_data = (array)$this->config->get('oct_popup_view_data');
    $data['oct_popup_view_data'] = $oct_popup_view_data;
    
    // oct_popup_purchase start
    $data['oct_popup_purchase_data'] = $this->config->get('oct_popup_purchase_data');
    // oct_popup_purchase end

    // oct_popup_found_cheaper start
    $data['oct_popup_found_cheaper_data'] = $this->config->get('oct_popup_found_cheaper_data');
    // oct_popup_found_cheaper end

    // oct_images_by_options start
    $data['oct_images_by_options_data'] = $this->config->get('oct_images_by_options_data');
    // oct_images_by_options end

    if (isset($this->request->get['product_id'])) {
      $product_id = (int)$this->request->get['product_id'];
    } else {
      $product_id = 0;
    }

    $product_info = $this->model_catalog_product->getProduct($product_id);

    $data['product_id'] = $product_id;

    if ($product_info) {

      $data['heading_title'] = $this->language->get('heading_title');
      
      $data['button_view'] = $this->language->get('button_view');
      $data['text_select'] = $this->language->get('text_select');
      $data['text_manufacturer'] = $this->language->get('text_manufacturer');
      $data['text_model'] = $this->language->get('text_model');
      $data['text_reward'] = $this->language->get('text_reward');
      $data['text_points'] = $this->language->get('text_points');
      $data['text_stock'] = $this->language->get('text_stock');
      $data['text_discount'] = $this->language->get('text_discount');
      $data['text_tax'] = $this->language->get('text_tax');
      $data['text_option'] = $this->language->get('text_option');
      $data['text_minimum'] = sprintf($this->language->get('text_minimum'), $product_info['minimum']);
      $data['text_write'] = $this->language->get('text_write');
      $data['text_login'] = sprintf($this->language->get('text_login'), $this->url->link('account/login', '', 'SSL'), $this->url->link('account/register', '', 'SSL'));
      $data['text_note'] = $this->language->get('text_note');
      $data['text_tags'] = $this->language->get('text_tags');
      $data['text_related'] = $this->language->get('text_related');
      $data['text_loading'] = $this->language->get('text_loading');

      $data['entry_qty'] = $this->language->get('entry_qty');
      $data['entry_name'] = $this->language->get('entry_name');
      $data['entry_review'] = $this->language->get('entry_review');
      $data['entry_rating'] = $this->language->get('entry_rating');
      $data['entry_good'] = $this->language->get('entry_good');
      $data['entry_bad'] = $this->language->get('entry_bad');

      $data['button_cart'] = $this->language->get('button_cart');
      $data['button_close'] = $this->language->get('button_close');
      $data['button_view'] = $this->language->get('button_view');
      $data['button_oct_popup_view'] = $this->language->get('button_oct_popup_view');
      $data['button_wishlist'] = $this->language->get('button_wishlist');
      $data['button_compare'] = $this->language->get('button_compare');
      $data['button_upload'] = $this->language->get('button_upload');
      $data['button_continue'] = $this->language->get('button_continue');
      $data['button_cart'] = $this->language->get('button_cart');
      $data['button_compare'] = $this->language->get('button_compare');
      $data['button_wishlist'] = $this->language->get('button_wishlist');
      $data['text_oct_popup_purchase'] = $this->language->get('text_oct_popup_purchase');
      $data['text_oct_popup_found_cheaper'] = $this->language->get('text_oct_popup_found_cheaper');
      
      $this->load->model('catalog/review');

      $data['tab_description'] = $this->language->get('tab_description');
      $data['tab_attribute'] = $this->language->get('tab_attribute');
      $data['tab_review'] = sprintf($this->language->get('tab_review'), $product_info['reviews']);

      $data['manufacturer'] = $product_info['manufacturer'];
      $data['manufacturers'] = $this->url->link('product/manufacturer/info', 'manufacturer_id=' . $product_info['manufacturer_id']);
      $data['model'] = $product_info['model'];
      $data['reward'] = $product_info['reward'];
      $data['points'] = $product_info['points'];

      $data['view_product_link'] = $this->url->link('product/product', 'product_id=' . $product_info['product_id']);
      
      $oct_data = $this->config->get('oct_luxury_data');
      $data['oct_luxury_pr_shortdesc'] = $oct_data['pr_shortdesc'];
      $data['quantity'] = $product_info['quantity'];
      $oct_luxury_pr_garantedtext = $oct_data['pr_garantedtext'];
		if(empty($oct_luxury_pr_garantedtext[$this->session->data['language']])) {
			$data['oct_luxury_pr_garantedtext'] = false;
		} else if (isset($oct_luxury_pr_garantedtext[$this->session->data['language']])) {
			$data['oct_luxury_pr_garantedtext'] = html_entity_decode($oct_luxury_pr_garantedtext[$this->session->data['language']], ENT_QUOTES, 'UTF-8');
		} 
      
      if ($product_info['quantity'] <= 0) {
        $data['stock_warning'] = $product_info['stock_status'];
      } else {
        $data['stock_warning'] = '';
      }

      $oct_product_stickers_data = $this->config->get('oct_product_stickers_data');
      $data['oct_product_stickers'] = array();

      if (isset($oct_product_stickers_data['status']) && $oct_product_stickers_data['status']) {
        $this->load->model('catalog/oct_product_stickers');

        if ($product_info['oct_product_stickers']) {
          $stickers = unserialize($product_info['oct_product_stickers']);
        } else {
          $stickers = array();
        }

        foreach ($stickers as $product_sticker_id) {
          $sticker_info = $this->model_catalog_oct_product_stickers->getProductSticker($product_sticker_id);
          
          if ($sticker_info) {
            $data['oct_product_stickers'][] = array(
              'text' => $sticker_info['text'],
              'color' => $sticker_info['color'],
              'background' => $sticker_info['background']
            );
          }
        }

        $sticker_sort_order = array();

        foreach ($stickers as $key => $product_sticker_id) {
          $sticker_info = $this->model_catalog_oct_product_stickers->getProductSticker($product_sticker_id);
          
          if ($sticker_info) {
            $sticker_sort_order[$key] = $sticker_info['sort_order'];
          }
        }
        
        array_multisort($sticker_sort_order, SORT_ASC, $data['oct_product_stickers']);
      }

      $oct_product_tabs_data = $this->config->get('oct_product_tabs_data');
      $data['oct_product_extra_tabs'] = array();

      if (isset($oct_product_tabs_data['status']) && $oct_product_tabs_data['status']) {
        $this->load->model('catalog/oct_product_tabs');

        $oct_product_extra_tabs = $this->model_catalog_oct_product_tabs->getProductTabs($product_info['product_id']);

        if ($oct_product_extra_tabs) {            
          foreach ($oct_product_extra_tabs as $extra_tab) {
            $data['oct_product_extra_tabs'][] = array(
              'title' => $extra_tab['title'],
              'text'  => html_entity_decode($extra_tab['text'], ENT_QUOTES, 'UTF-8')
            );
          }
        }
      }

      if ($product_info['quantity'] <= 0) {
        $data['stock'] = $product_info['stock_status'];
      } elseif ($this->config->get('config_stock_display')) {
        $data['stock'] = $product_info['quantity'];
      } else {
        $data['stock'] = $this->language->get('text_instock');
      }

      $data['product_name'] = $product_info['name'];

      $this->load->model('tool/image');

      $image_width = ($oct_popup_view_data['image_width']) ? $oct_popup_view_data['image_width'] : '300';
      $image_height = ($oct_popup_view_data['image_height']) ? $oct_popup_view_data['image_height'] : '300';

      if ($product_info['image']) {
        $data['thumb'] = $this->model_tool_image->resize($product_info['image'], $image_width, $image_height);
      } else {
        $data['thumb'] = $this->model_tool_image->resize("placeholder.png", $image_width, $image_height);
      }

      $data['images'] = array();

      $results = $this->model_catalog_product->getProductImages($product_id);

      $image_additional_width = ($oct_popup_view_data['image_additional_width']) ? $oct_popup_view_data['image_additional_width'] : '59';
      $image_additional_height = ($oct_popup_view_data['image_additional_height']) ? $oct_popup_view_data['image_additional_height'] : '59';

      foreach ($results as $result) {
        $data['images'][] = array(
          'popup' => $this->model_tool_image->resize($result['image'], $image_width, $image_height),
          'thumb' => $this->model_tool_image->resize($result['image'], $image_additional_width, $image_additional_height)
        );
      }

      if (($this->config->get('config_customer_price') && $this->customer->isLogged()) || !$this->config->get('config_customer_price')) {
        $data['price'] = $this->currency->format($this->tax->calculate($product_info['price'], $product_info['tax_class_id'], $this->config->get('config_tax')));
      } else {
        $data['price'] = false;
      }

      if ((float)$product_info['special']) {
        $data['special'] = $this->currency->format($this->tax->calculate($product_info['special'], $product_info['tax_class_id'], $this->config->get('config_tax')));
      } else {
        $data['special'] = false;
      }

      if ((float)$product_info['special']) {
        $data['economy'] = round((($product_info['price'] - $product_info['special'])/($product_info['price'] + 0.01))*100, 0);
      } else {
        $data['economy'] = false;
      }

      if ($this->config->get('config_tax')) {
        $data['tax'] = $this->currency->format((float)$product_info['special'] ? $product_info['special'] : $product_info['price']);
      } else {
        $data['tax'] = false;
      }

      $data['points'] = $product_info['points'];

      $discounts = $this->model_catalog_product->getProductDiscounts($product_id);

      $data['discounts'] = array();

      foreach ($discounts as $discount) {
        $data['discounts'][] = array(
          'quantity' => $discount['quantity'],
          'price'    => $this->currency->format($this->tax->calculate($discount['price'], $product_info['tax_class_id'], $this->config->get('config_tax')))
        );
      }

      if ($oct_popup_view_data['description_max']) {
        $data['description'] = strip_tags(html_entity_decode($product_info['description'], ENT_QUOTES, 'UTF-8') , '<p><ul><li><b><strong><a><i><u><br></br><span>');
      } else {
        $data['description'] = html_entity_decode($product_info['description'], ENT_QUOTES, 'UTF-8');
      }

      if ($product_info['minimum']) {
        $data['minimum'] = $product_info['minimum'];
      } else {
        $data['minimum'] = 1;
      }

      $data['options'] = array();

      foreach ($this->model_catalog_product->getProductOptions($product_id) as $option) {
        $product_option_value_data = array();

        foreach ($option['product_option_value'] as $option_value) {
          if (!$option_value['subtract'] || ($option_value['quantity'] > 0)) {
            if ((($this->config->get('config_customer_price') && $this->customer->isLogged()) || !$this->config->get('config_customer_price')) && (float)$option_value['price']) {
              $price = $this->currency->format($this->tax->calculate($option_value['price'], $product_info['tax_class_id'], $this->config->get('config_tax') ? 'P' : false));
            } else {
              $price = false;
            }

            $product_option_value_data[] = array(
              'product_option_value_id' => $option_value['product_option_value_id'],
              'option_value_id'         => $option_value['option_value_id'],
              'name'                    => $option_value['name'],
              'image'                   => $this->model_tool_image->resize($option_value['image'], 50, 50),
              'price'                   => $price,
              'price_prefix'            => $option_value['price_prefix']
           );
          }
        }

        $data['options'][] = array(
          'product_option_id'    => $option['product_option_id'],
          'product_option_value' => $product_option_value_data,
          'option_id'            => $option['option_id'],
          'name'                 => $option['name'],
          'type'                 => $option['type'],
          'value'                => $option['value'],
          'required'             => $option['required']
        );
      }

      $data['review_status'] = $this->config->get('config_review_status');

      if ($this->config->get('config_review_guest') || $this->customer->isLogged()) {
        $data['review_guest'] = true;
      } else {
        $data['review_guest'] = false;
      }

      if ($this->customer->isLogged()) {
        $data['customer_name'] = $this->customer->getFirstName() . '&nbsp;' . $this->customer->getLastName();
      } else {
        $data['customer_name'] = '';
      }

      $data['reviews'] = sprintf($this->language->get('text_reviews'), (int)$product_info['reviews']);
      $data['rating'] = (int)$product_info['rating'];
      $data['attribute_groups'] = $this->model_catalog_product->getProductAttributes($this->request->get['product_id']);

      $data['recurrings'] = $this->model_catalog_product->getProfiles($product_id);
      $data['tags'] = array();

      if ($product_info['tag']) {
        $tags = explode(',', $product_info['tag']);

        foreach ($tags as $tag) {
          $data['tags'][] = array(
            'tag'  => trim($tag),
            'href' => $this->url->link('product/search', 'tag=' . trim($tag))
          );
        }
      }

      $data['text_payment_recurring'] = $this->language->get('text_payment_recurring');
      
      if ($this->config->get('config_google_captcha_status')) {
        $this->document->addScript('https://www.google.com/recaptcha/api.js');

        $data['site_key'] = $this->config->get('config_google_captcha_public');
      } else {
        $data['site_key'] = '';
      }

      if(file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/module/oct_popup_view.tpl')) {
        $view = $this->load->view($this->config->get('config_template') . '/template/module/oct_popup_view.tpl', $data);
      } else {
        $view = $this->load->view('default/template/module/oct_popup_view.tpl', $data);
      }

      $this->response->setOutput($view);
    } else {
      die();
    }
  }

  public function update_prices() {
    $json = array();

    if (isset($this->request->request['product_id']) && isset($this->request->request['quantity'])) {

      $this->load->model('catalog/product');

      $product_id      = (int)$this->request->request['product_id'];
      $product_info    = (array)$this->model_catalog_product->getProduct($product_id);
      $option_price    = 0;
      $quantity        = (int)$this->request->request['quantity'];
      $product_options = (array)$this->model_catalog_product->getProductOptions($product_id);

      if (!empty($this->request->request['option'])) {
        $option = $this->request->request['option'];
      } else {
        $option = array();
      }

      foreach ($product_options as $product_option) {
        if (is_array($product_option['product_option_value'])) {
          foreach ($product_option['product_option_value'] as $option_value) {
            if(isset($option[$product_option['product_option_id']])) {
              if(($option[$product_option['product_option_id']] == $option_value['product_option_value_id']) || ((is_array($option[$product_option['product_option_id']])) && (in_array($option_value['product_option_value_id'], $option[$product_option['product_option_id']])))) {
                if ($option_value['price_prefix'] == '+') {
                    $option_price += $option_value['price'];
                } elseif ($option_value['price_prefix'] == '-') {
                    $option_price -= $option_value['price'];
                }
              }
            }
          }
        }
      }

      $json['special'] = $this->currency->format(($this->tax->calculate($this->get_price_discount($product_id, $quantity), $product_info['tax_class_id'], $this->config->get('config_tax')) * $quantity) + $this->tax->calculate($option_price * $quantity, $product_info['tax_class_id'], $this->config->get('config_tax')));

      if ($json['special']) {
        $economy = round(((($this->tax->calculate($product_info['price'], $product_info['tax_class_id'], $this->config->get('config_tax')) * $quantity) - ($this->tax->calculate($this->get_price_discount($product_id, $quantity), $product_info['tax_class_id'], $this->config->get('config_tax')) * $quantity))/(($this->tax->calculate($product_info['price'], $product_info['tax_class_id'], $this->config->get('config_tax')) * $quantity) + 0.01))*100, 0); 
        $saver = round(($this->tax->calculate($product_info['price'], $product_info['tax_class_id'], $this->config->get('config_tax'))) - ($this->tax->calculate($this->get_price_discount($product_id, $quantity), $product_info['tax_class_id'], $this->config->get('config_tax'))));                  
        $json['you_save'] = $this->currency->format(($this->tax->calculate($saver, $product_info['tax_class_id'], $this->config->get('config_tax')) * $quantity) + $this->tax->calculate($quantity * $product_info['tax_class_id'], $this->config->get('config_tax'))) . ' (-'.$economy.'%)';
      } else {
        $json['you_save'] = false;
      }

      $json['price']   = $this->currency->format(($this->tax->calculate($product_info['price'], $product_info['tax_class_id'], $this->config->get('config_tax')) * $quantity) + $this->tax->calculate($option_price * $quantity, $product_info['tax_class_id'], $this->config->get('config_tax')));
      $json['tax']     = $this->currency->format(($this->get_price_discount($product_id, $quantity) + $option_price) * $quantity);
    }

    $this->response->addHeader('Content-Type: application/json');
    $this->response->setOutput(json_encode($json));
  }

  public function get_price_discount($product_id, $quantity) {
    $this->load->model('catalog/product');

    $customer_group_id = ($this->customer->isLogged()) ? (int)$this->customer->getGroupId() : (int)$this->config->get('config_customer_group_id');

    $product_info = (array)$this->model_catalog_product->getProduct($product_id);

    $price = $product_info['price'];

    $product_discount_query = $this->db->query("SELECT price FROM " . DB_PREFIX . "product_discount WHERE product_id = '" . (int)$product_id . "' AND customer_group_id = '" . (int)$customer_group_id . "' AND quantity <= '" . (int)$quantity . "' AND ((date_start = '0000-00-00' OR date_start < NOW()) AND (date_end = '0000-00-00' OR date_end > NOW())) ORDER BY quantity DESC, priority ASC, price ASC LIMIT 1");
    if ($product_discount_query->num_rows) {
        $price = $product_discount_query->row['price'];
    }

    $product_special_query = $this->db->query("SELECT price FROM " . DB_PREFIX . "product_special WHERE product_id = '" . (int)$product_id . "' AND customer_group_id = '" . (int)$customer_group_id . "' AND ((date_start = '0000-00-00' OR date_start < NOW()) AND (date_end = '0000-00-00' OR date_end > NOW())) ORDER BY priority ASC, price ASC LIMIT 1");

    if ($product_special_query->num_rows) {
      $price = $product_special_query->row['price'];
    }

    return $price;
  }

  public function write() {
    $this->load->language('product/product');

    $json = array();

    if ($this->request->server['REQUEST_METHOD'] == 'POST') {
      if ((utf8_strlen($this->request->post['name']) < 3) || (utf8_strlen($this->request->post['name']) > 25)) {
        $json['error'] = $this->language->get('error_name');
      }

      if ((utf8_strlen($this->request->post['text']) < 25) || (utf8_strlen($this->request->post['text']) > 1000)) {
        $json['error'] = $this->language->get('error_text');
      }

      if (empty($this->request->post['rating']) || $this->request->post['rating'] < 0 || $this->request->post['rating'] > 5) {
        $json['error'] = $this->language->get('error_rating');
      }

      if (!isset($json['error'])) {
        $this->load->model('catalog/review');

        $this->model_catalog_review->addReview($this->request->get['product_id'], $this->request->post);

        $json['success'] = $this->language->get('text_success');
      }
    }

    $this->response->addHeader('Content-Type: application/json');
    $this->response->setOutput(json_encode($json));
  }
}