<?php
class ControllerOctemplatesBlogArticle extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('octemplates/blog_article');
		$this->load->language('octemplates/luxury');
		
		$data['oct_home_text'] = $this->language->get('oct_home_text'); 

		$oct_blog_setting_data = $this->config->get('oct_blog_setting_data');

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home')
		);

		$this->load->model('octemplates/blog_category');

		if (isset($this->request->get['cpath'])) {

			$category_info = $this->model_octemplates_blog_category->getCategory($this->request->get['cpath']);

			if ($category_info) {
				$url = '';

				if (isset($this->request->get['sort'])) {
					$url .= '&sort=' . $this->request->get['sort'];
				}

				if (isset($this->request->get['order'])) {
					$url .= '&order=' . $this->request->get['order'];
				}

				if (isset($this->request->get['page'])) {
					$url .= '&page=' . $this->request->get['page'];
				}

				if (isset($this->request->get['limit'])) {
					$url .= '&limit=' . $this->request->get['limit'];
				}

				$data['breadcrumbs'][] = array(
					'text' => $category_info['name'],
					'href' => $this->url->link('octemplates/blog_category', 'cpath=' . $this->request->get['cpath'] . $url)
				);
			}
		}

		if (isset($this->request->get['oct_blog_article_id'])) {
			$oct_blog_article_id = (int)$this->request->get['oct_blog_article_id'];
		} else {
			$oct_blog_article_id = 0;
		}

		$this->load->model('octemplates/blog_article');

		$article_info = $this->model_octemplates_blog_article->getArticle($oct_blog_article_id);

		if ($article_info) {
			$url = '';

			if (isset($this->request->get['cpath'])) {
				$url .= '&cpath=' . $this->request->get['cpath'];
			}

			if (isset($this->request->get['tag'])) {
				$url .= '&tag=' . $this->request->get['tag'];
			}

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			if (isset($this->request->get['limit'])) {
				$url .= '&limit=' . $this->request->get['limit'];
			}

			$data['breadcrumbs'][] = array(
				'text' => $article_info['name'],
				'href' => $this->url->link('octemplates/blog_article', $url . '&oct_blog_article_id=' . $this->request->get['oct_blog_article_id'])
			);

			$this->document->setTitle($article_info['meta_title']);
			$this->document->setDescription($article_info['meta_description']);
			$this->document->setKeywords($article_info['meta_keyword']);
			$this->document->addLink($this->url->link('octemplates/blog_article', 'oct_blog_article_id=' . $this->request->get['oct_blog_article_id']), 'canonical');
			$this->document->addScript('catalog/view/javascript/jquery/magnific/jquery.magnific-popup.min.js');
			$this->document->addStyle('catalog/view/javascript/jquery/magnific/magnific-popup.css');

			$data['heading_title'] = $article_info['name'];

			$data['text_select'] = $this->language->get('text_select');
			$data['text_write'] = $this->language->get('text_write');
			$data['text_login'] = sprintf($this->language->get('text_login'), $this->url->link('account/login', '', 'SSL'), $this->url->link('account/register', '', 'SSL'));
			$data['text_note'] = $this->language->get('text_note');
			$data['text_tags'] = $this->language->get('text_tags');
			$data['text_related_products'] = $this->language->get('text_related_products');
			$data['text_related_articles'] = $this->language->get('text_related_articles');
			$data['text_loading'] = $this->language->get('text_loading');
			$data['text_comments'] = $this->language->get('text_comments');
			$data['text_viewed'] = $this->language->get('text_viewed');
			$data['text_date_added'] = $this->language->get('text_date_added');
			$data['text_tax'] = $this->language->get('text_tax');
			$data['text_rating'] = $this->language->get('text_rating');
				
						
			$this->load->language('octemplates/luxury');
			$data['button_wishlist'] = $this->language->get('button_wishlist');
			$data['button_compare'] = $this->language->get('button_compare');	
				
			$data['entry_name'] = $this->language->get('entry_name');
			$data['entry_comment'] = $this->language->get('entry_comment');
			$data['entry_rating'] = $this->language->get('entry_rating');
			$data['entry_good'] = $this->language->get('entry_good');
			$data['entry_bad'] = $this->language->get('entry_bad');

			$data['button_continue'] = $this->language->get('button_continue');
			$data['button_cart'] = $this->language->get('button_cart');
			
			$data['description'] = html_entity_decode($article_info['description'], ENT_QUOTES, 'UTF-8');

			$this->load->model('tool/image');

			if ($article_info['image']) {
				$data['popup'] = $this->model_tool_image->resize($article_info['image'], $oct_blog_setting_data['main_image_popup_width'], $oct_blog_setting_data['main_image_popup_height']);
			} else {
				$data['popup'] = '';
			}

			if ($article_info['image']) {
				$data['thumb'] = $this->model_tool_image->resize($article_info['image'], $oct_blog_setting_data['main_image_width'], $oct_blog_setting_data['main_image_height']);
			} else {
				$data['thumb'] = '';
			}

			$data['images'] = array();

			$results = $this->model_octemplates_blog_article->getArticleImages($this->request->get['oct_blog_article_id']);

			foreach ($results as $result) {
				$data['images'][] = array(
					'popup' => $this->model_tool_image->resize($result['image'], $this->config->get('config_image_popup_width'), $this->config->get('config_image_popup_height')),
					'thumb' => $this->model_tool_image->resize($result['image'], $oct_blog_setting_data['sub_image_width'], $oct_blog_setting_data['sub_image_height'])
				);
			}

			if ($this->customer->isLogged()) {
				$data['customer_name'] = $this->customer->getFirstName() . '&nbsp;' . $this->customer->getLastName();
			} else {
				$data['customer_name'] = '';
			}

			$data['oct_blog_article_id'] = (int)$article_info['oct_blog_article_id'];
			$data['comments'] = (int)$article_info['comments'];
			$data['viewed'] = (int)$article_info['viewed'];
			$data['date_added'] = $article_info['date_added'];

			$oct_blog_setting = $this->config->get('oct_blog_setting_data');

			if (isset($oct_blog_setting['comment_show']) && $oct_blog_setting['comment_show'] == 1) {
				$data['comment_show'] = true;
			} else {
				$data['comment_show'] = false;
			}

			if (isset($oct_blog_setting['comment_write']) && $oct_blog_setting['comment_write'] == 1) {
				$data['comment_write'] = true;
			} else {
				$data['comment_write'] = false;
			}

			// Captcha
			if ($this->config->get($this->config->get('config_captcha') . '_status') && in_array('comments', (array)$this->config->get('config_captcha_page'))) {
				$data['captcha'] = $this->load->controller('captcha/' . $this->config->get('config_captcha'));
			} else {
				$data['captcha'] = '';
			}

			$data['tags'] = array();

			if ($article_info['tag']) {
				$tags = explode(',', $article_info['tag']);

				foreach ($tags as $tag) {
					$data['tags'][] = array(
						'tag'  => trim($tag),
						'href' => $this->url->link('octemplates/blog_search', 'tag=' . trim($tag))
					);
				}
			}

			
			$data['products'] = array();

			$p_results = $this->model_octemplates_blog_article->getArticleProductsRelated($this->request->get['oct_blog_article_id']);

			foreach ($p_results as $result) {
				if ($result['image']) {
					$image = $this->model_tool_image->resize($result['image'], $oct_blog_setting_data['r_p_image_width'], $oct_blog_setting_data['r_p_image_height']);
				} else {
					$image = $this->model_tool_image->resize('placeholder.png', $oct_blog_setting_data['r_p_image_width'], $oct_blog_setting_data['r_p_image_height']);
				}

				if (($this->config->get('config_customer_price') && $this->customer->isLogged()) || !$this->config->get('config_customer_price')) {
					$price = $this->currency->format($this->tax->calculate($result['price'], $result['tax_class_id'], $this->config->get('config_tax')));
				} else {
					$price = false;
				}

				if ((float)$result['special']) {
					$special = $this->currency->format($this->tax->calculate($result['special'], $result['tax_class_id'], $this->config->get('config_tax')));
				} else {
					$special = false;
				}

				if ($this->config->get('config_tax')) {
					$tax = $this->currency->format((float)$result['special'] ? $result['special'] : $result['price']);
				} else {
					$tax = false;
				}

				if ($this->config->get('config_review_status')) {
					$rating = (int)$result['rating'];
				} else {
					$rating = false;
				}

				$data['products'][] = array(
					'product_id'  => $result['product_id'],
					'thumb'       => $image,
					'name'        => $result['name'],
					'description' => utf8_substr(strip_tags(html_entity_decode($result['description'], ENT_QUOTES, 'UTF-8')), 0, $this->config->get('config_product_description_length')) . '..',
					'price'       => $price,
					'special'     => $special,
					'tax'         => $tax,
					'minimum'     => $result['minimum'] > 0 ? $result['minimum'] : 1,
					'rating'      => $rating,
					'href'        => $this->url->link('product/product', 'product_id=' . $result['product_id'])
				);
			}

			$data['articles'] = array();

			$a_results = $this->model_octemplates_blog_article->getArticleArticlesRelated($this->request->get['oct_blog_article_id']);

			foreach ($a_results as $result) {
				if ($result['image']) {
					$image = $this->model_tool_image->resize($result['image'], $oct_blog_setting_data['r_a_image_width'], $oct_blog_setting_data['r_a_image_height']);
				} else {
					$image = $this->model_tool_image->resize('placeholder.png', $oct_blog_setting_data['r_a_image_width'], $oct_blog_setting_data['r_a_image_height']);
				}

				if ($this->config->get('config_review_status')) {
					$rating = (int)$result['rating'];
				} else {
					$rating = false;
				}

				$data['articles'][] = array(
					'oct_blog_article_id'  => $result['oct_blog_article_id'],
					'thumb'       => $image,
					'name'        => $result['name'],
					'date_added'        => $result['date_added'],
					'comments'        => $result['comments'] ? $result['comments'] : 0,
					'viewed'        => $result['viewed'],
					'description' => utf8_substr(strip_tags(html_entity_decode($result['description'], ENT_QUOTES, 'UTF-8')), 0, $oct_blog_setting_data['desc_limit']) . '..',
					'rating'      => $rating,
					'href'        => $this->url->link('octemplates/blog_article', '&oct_blog_article_id=' . $result['oct_blog_article_id'])
				);
			}

			$this->model_octemplates_blog_article->updateViewed($this->request->get['oct_blog_article_id']);

			$data['column_left'] = $this->load->controller('common/column_left');
			$data['column_right'] = $this->load->controller('common/column_right');
			$data['content_top'] = $this->load->controller('common/content_top');
			$data['content_bottom'] = $this->load->controller('common/content_bottom');
			$data['footer'] = $this->load->controller('common/footer');
			$data['header'] = $this->load->controller('common/header');

			if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/octemplates/blog_article.tpl')) {
				$this->response->setOutput($this->load->view($this->config->get('config_template') . '/template/octemplates/blog_article.tpl', $data));
			} else {
				$this->response->setOutput($this->load->view('default/template/octemplates/blog_article.tpl', $data));
			}
		} else {
			$url = '';

			if (isset($this->request->get['cpath'])) {
				$url .= '&cpath=' . $this->request->get['cpath'];
			}

			if (isset($this->request->get['tag'])) {
				$url .= '&tag=' . $this->request->get['tag'];
			}

			if (isset($this->request->get['sort'])) {
				$url .= '&sort=' . $this->request->get['sort'];
			}

			if (isset($this->request->get['order'])) {
				$url .= '&order=' . $this->request->get['order'];
			}

			if (isset($this->request->get['page'])) {
				$url .= '&page=' . $this->request->get['page'];
			}

			if (isset($this->request->get['limit'])) {
				$url .= '&limit=' . $this->request->get['limit'];
			}

			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('text_error'),
				'href' => $this->url->link('octemplates/blog_article', $url . '&oct_blog_article_id=' . $oct_blog_article_id)
			);

			$this->document->setTitle($this->language->get('text_error'));

			$data['heading_title'] = $this->language->get('text_error');

			$data['text_error'] = $this->language->get('text_error');

			$data['button_continue'] = $this->language->get('button_continue');

			$data['continue'] = $this->url->link('common/home');

			$this->response->addHeader($this->request->server['SERVER_PROTOCOL'] . ' 404 Not Found');

			$data['column_left'] = $this->load->controller('common/column_left');
			$data['column_right'] = $this->load->controller('common/column_right');
			$data['content_top'] = $this->load->controller('common/content_top');
			$data['content_bottom'] = $this->load->controller('common/content_bottom');
			$data['footer'] = $this->load->controller('common/footer');
			$data['header'] = $this->load->controller('common/header');

			if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/error/not_found.tpl')) {
				$this->response->setOutput($this->load->view($this->config->get('config_template') . '/template/error/not_found.tpl', $data));
			} else {
				$this->response->setOutput($this->load->view('default/template/error/not_found.tpl', $data));
			}
		}
	}

	public function comments() {
		$this->load->language('octemplates/blog_article');

		$this->load->model('octemplates/blog_comments');

		$data['text_no_comments'] = $this->language->get('text_no_comments');

		if (isset($this->request->get['page'])) {
			$page = $this->request->get['page'];
		} else {
			$page = 1;
		}

		$data['comments'] = array();

		$comments_total = $this->model_octemplates_blog_comments->getTotalCommentsByArticleId($this->request->get['oct_blog_article_id']);

		$results = $this->model_octemplates_blog_comments->getCommentsByArticleId($this->request->get['oct_blog_article_id'], ($page - 1) * 5, 5);

		foreach ($results as $result) {
			$data['comments'][] = array(
				'oct_blog_comment_id' => $result['oct_blog_comment_id'],
				'author'     => $result['author'],
				'plus'       => $result['plus'],
				'minus'      => $result['minus'],
				'text'       => nl2br($result['text']),
				'rating'     => (int)$result['rating'],
				'date_added' => date($this->language->get('date_format_short'), strtotime($result['date_added']))
			);
		}

		$pagination = new Pagination();
		$pagination->total = $comments_total;
		$pagination->page = $page;
		$pagination->limit = 5;
		$pagination->url = $this->url->link('octemplates/blog_article/comments', 'oct_blog_article_id=' . $this->request->get['oct_blog_article_id'] . '&page={page}');

		$data['pagination'] = $pagination->render();

		$data['results'] = sprintf($this->language->get('text_pagination'), ($comments_total) ? (($page - 1) * 5) + 1 : 0, ((($page - 1) * 5) > ($comments_total - 5)) ? $comments_total : ((($page - 1) * 5) + 5), $comments_total, ceil($comments_total / 5));

		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/octemplates/blog_comments.tpl')) {
			$this->response->setOutput($this->load->view($this->config->get('config_template') . '/template/octemplates/blog_comments.tpl', $data));
		} else {
			$this->response->setOutput($this->load->view('default/template/octemplates/blog_comments.tpl', $data));
		}
	}

	public function write() {
		$this->load->language('octemplates/blog_article');

		$json = array();

		if ($this->request->server['REQUEST_METHOD'] == 'POST') {
			if ((utf8_strlen($this->request->post['name']) < 3) || (utf8_strlen($this->request->post['name']) > 25)) {
				$json['error'] = $this->language->get('error_name');
			}

			if ((utf8_strlen($this->request->post['text']) < 25) || (utf8_strlen($this->request->post['text']) > 1000)) {
				$json['error'] = $this->language->get('error_text');
			}

			if (empty($this->request->post['rating']) || $this->request->post['rating'] < 0 || $this->request->post['rating'] > 5) {
				$json['error'] = $this->language->get('error_rating');
			}

			// Captcha
			if ($this->config->get($this->config->get('config_captcha') . '_status') && in_array('comments', (array)$this->config->get('config_captcha_page'))) {
				$captcha = $this->load->controller('captcha/' . $this->config->get('config_captcha') . '/validate');

				if ($captcha) {
					$json['error'] = $captcha;
				}
			}

			if (!isset($json['error'])) {
				$this->load->model('octemplates/blog_comments');

				$this->model_octemplates_blog_comments->addComment($this->request->get['oct_blog_article_id'], $this->request->post);

				$json['success'] = $this->language->get('text_success');
			}
		}

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}

	public function comment_plus() {
		$this->load->language('octemplates/blog_article');
		$this->load->model('octemplates/blog_comments');

		$json = array();

		$filter_data = array(
			'customer_ip' => $this->request->server['REMOTE_ADDR'],
			'customer_id' => (int)$this->customer->getId()
		);

		$check_like = $this->model_octemplates_blog_comments->checkLike($this->request->request['oct_blog_comment_id'], $this->request->request['oct_blog_article_id'], $filter_data);

		if ($check_like) {
			$json['error'] = $this->language->get('error_already_voted');
		}
			
		if (!isset($json['error'])) {
			$this->model_octemplates_blog_comments->updateLike($this->request->request['oct_blog_comment_id'], $this->request->request['oct_blog_article_id'], 'plus');

			$this->model_octemplates_blog_comments->addCommentLike($this->request->request['oct_blog_comment_id'], $this->request->request['oct_blog_article_id'], $filter_data);

			$json['value'] = $this->model_octemplates_blog_comments->getLikeCount($this->request->request['oct_blog_comment_id'], $this->request->request['oct_blog_article_id'], 'c.plus');
		}

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}

	public function comment_minus() {
		$this->load->language('octemplates/blog_article');
		$this->load->model('octemplates/blog_comments');

		$json = array();

		$filter_data = array(
			'customer_ip' => $this->request->server['REMOTE_ADDR'],
			'customer_id' => (int)$this->customer->getId()
		);

		$check_like = $this->model_octemplates_blog_comments->checkLike($this->request->request['oct_blog_comment_id'], $this->request->request['oct_blog_article_id'], $filter_data);

		if ($check_like) {
			$json['error'] = $this->language->get('error_already_voted');
		}
			
		if (!isset($json['error'])) {
			$this->model_octemplates_blog_comments->updateLike($this->request->request['oct_blog_comment_id'], $this->request->request['oct_blog_article_id'], 'minus');

			$this->model_octemplates_blog_comments->addCommentLike($this->request->request['oct_blog_comment_id'], $this->request->request['oct_blog_article_id'], $filter_data);

			$json['value'] = $this->model_octemplates_blog_comments->getLikeCount($this->request->request['oct_blog_comment_id'], $this->request->request['oct_blog_article_id'], 'c.minus');
		}
		
		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}
}
